#include "h.h"
#include "hw.h"
#ifdef PIC18
#include "p18f452.h"
#endif

#pragma udata u3

//SUBPROCESO3, lee la eeprom al refrescar variables visualizadas
u16 dir;
u8  dato;

void lee_eeprom(void)
{
dato=EEPROMRead(dir);
}

//SUBPROCESO2, lee desde el ADC
u16 wn,wd;
s16 nCero,nSenal;
void ProcesaSenal(void)
{
s32 l;
//wadc=<<1;por filtrado, sacar un bit mas
if(wd)
	{
	l=wadc0;
	l*=wn;
	l/=wd;
	}
nSenal=l+nCero;
}

void RELEOff(void);
void RELEOn(void);

#ifdef PIC18
#define LEDSupOn()  PORTEbits.RE1=0
#define LEDSupOff() PORTEbits.RE1=1
#define LEDInfOn()  PORTEbits.RE2=0
#define LEDInfOff() PORTEbits.RE2=1
#endif
#ifndef PIC18
#define LEDSupOn()
#define LEDSupOff()
#define LEDInfOn()
#define LEDInfOff()
#endif


void RELEOn(void)
{
#ifdef PIC18
PORTAbits.RA4=0;
PORTAbits.RA5=0;
TRISAbits.TRISA4=0;
TRISAbits.TRISA5=0;
#endif
}

void RELEOff(void)
{
#ifdef PIC18
TRISAbits.TRISA4=1;
TRISAbits.TRISA5=1;
PORTAbits.RA4=1;
PORTAbits.RA5=1;
#endif
}


//SUBPROCESO UNO, generea seales de control de la 11063
bit RA3;
u8 e;
u16 wpes,wrap,wafn,wtdes,wzero;
void PROCESOLoop(void)
{
#ifdef PIC18
switch(e)
	{
    case 0:
        LEDInfOn();
		LEDSupOff();
        wpes=wadc1;
		wpes>>=3;     // xx11.x22x.xxxx.xxxx
		wpes&=0x0070; // 0000.0111.0000
        if(!PORTAbits.RA2)e=1; //DER
        break;
    case 1:
		LEDInfOff();
        LEDSupOff();
        RELEOn();
		wpes=0;
        if(!PORTBbits.RB1)e=2; //AFN
        break;
    case 2:
        LEDInfOn();
        LEDSupOn();
        RELEOn();
        wpes++;
		if( PORTBbits.RB1)e=3; //AFN
        break;
    case 3:
		LEDInfOff();
        LEDSupOff();
        RELEOn();
        if(!PORTBbits.RB1)e=2; //AFN
        if(!PORTBbits.RB2)e=4; //DES
        break;
    case 4:
        LEDInfOff();
        LEDSupOn();
		RELEOff();
        wpes--;
        if( PORTBbits.RB2)e=1; //DES
		break;
    case 9:
		LEDInfOn();
        LEDSupOff();
        RELEOff();
		wpes=96;
		if(RA3)e=0;  //IZQ
		break;
	}
if(wadc3<512)RA3=0;else RA3=1;
if(!RA3)e=9;//IZQ
ADCRead();
ProcesaSenal();
wdac2=0x80+wzero+wpes;
wdac1=0x80-wzero-wpes;
if(wdac2>0xff){wdac2=0xff;wdac1=0;} //logica de saturacion
PWMWrite();
#endif
}


void PROCESOReset(void)
{
e=0;
}

void PROCESOStop(void)
{
}

void PROCESOInterrupcion(void)
{
}

